/*
 
 //This file is licensed under the terms of the CC-LGPL
 
 CL_rlp_fourier_series_test.pov
 
 Here's a demonstration of how you might make sum and product objects with the CL macros.
 
*/
  ////
 //   example   //
//_____________//
global_settings{charset utf8 assumed_gamma 1.0}   // Remove this and get  for space, i.e. DON'T remove this.
//
#include "colors.inc"
#include "chars.inc"
#include "rlp.inc"    // Sam Benge's rounded linear prism #macros, available from the Object Collection.
#include "CL_rlp_capital_letters_160714.inc" 
// Define the string to be typeset
CL_rlp_make_text_string_set(3) // Defines CL_default_space,CL_small_space,CL_math_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,
//                                        CL_font_type,CL_dimensions_out as globals
#declare CL_debug_lines   =  0;
#declare CL_z1            = -1;      // Getting a deeper 3D
#declare CL_z2            =  1;
//
// Square integrable line
//   
#declare temp_dims        = array[4];
#declare foft             = object{CL_rlp_make_text_string("#f(t)",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,temp_dims)} 
#declare foft_dims        = temp_dims; 
#declare bracket_foft     = object{CL_rlp_make_elastic_bracket_pair(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                foft,CL_tiny_space,1,1,temp_dims,CL_dimensions_out)}
#declare temp_dims        = CL_dimensions_out; 
#declare squared_foft     = object{CL_rlp_make_supersubscript(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                              bracket_foft,"","","#2",0,CL_letter_adjust,CL_letter_adjust,0,
                                                              temp_dims,CL_dimensions_out) }  
#declare temp_dims        = CL_dimensions_out; 
#declare squ_int_object   = object{CL_rlp_make_integral(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,
                                                        CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        squared_foft,"","#t","#0","#T",CL_medium_space,CL_medium_space,1,temp_dims,CL_dimensions_out)} 
#declare squ_int_obj_dims = CL_dimensions_out;
#declare temp_dims        = CL_dimensions_out;
#declare If               = object{CL_rlp_make_text_string("If",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)}  
//
#declare part_dims        = array[2]
#declare part_dims[0]     = CL_dimensions_out;
#declare part_dims[1]     = temp_dims;
#declare lhs_object       = object{CL_rlp_make_concatenate(If,squ_int_object,CL_medium_space,part_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;
#declare rhs_object       = object{CL_rlp_make_text_string("#|8# and #f(t)# is of bounded variation, then",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                            CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)}  
#declare part_dims[0]     = temp_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare first_object     = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                       lhs_object,rhs_object,0," < ",CL_medium_space,part_dims,CL_dimensions_out)} 
//
object{first_object translate <-20,23,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
// Fourier series line 
//
#declare text_func_elts   = array[4]{"#a|!_n#cos","#2n|pt","#T",""};
#declare cos_term         = object{CL_rlp_make_text_function_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,
                                                                      CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                      text_func_elts,1,1,
                                                                      CL_medium_space,CL_medium_space,0,CL_dimensions_out)}  
#declare temp_dims        = CL_dimensions_out;
#local text_func_elts     = array[4]{"#b|!|!_n#sin","#2n|pt","#T",""};
#local sin_term           = object{CL_rlp_make_text_function_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,
                                                                      CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                      text_func_elts,1,1,
                                                                      CL_medium_space,CL_medium_space,0,CL_dimensions_out)} 
#declare part_dims[0]     = temp_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare inside_object    = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                       cos_term,sin_term,0," + ",CL_medium_space,part_dims,CL_dimensions_out)}  
#declare temp_dims        = CL_dimensions_out;                                      
#declare sum_object       = object{CL_rlp_make_sumprod(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                       inside_object,"","#n=1","#|8",CL_medium_space,1,0,temp_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                      
#declare a0o2             =  object{CL_rlp_make_text_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                    "#a_0","#2",CL_medium_space,CL_dimensions_out)}
#declare part_dims[1]     = temp_dims;
#declare part_dims[0]     = CL_dimensions_out;
#declare in_lhs_object    = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        a0o2,sum_object,0," + ",CL_medium_space,part_dims,CL_dimensions_out)}  
#declare part_dims[0]     = foft_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare second_object    = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        foft,in_lhs_object,0,"# ~ ",CL_medium_space,part_dims,CL_dimensions_out)}  
#declare second_eqn_cent  = CL_dimensions_out[2];
//
object{second_object translate <-CL_dimensions_out[2],16,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
// a_0 line
//
#declare where            = object{CL_rlp_make_text_string("where",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)} 
#declare where_dims       = CL_dimensions_out;                                                 
object{where translate <-20,8,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
#declare twoot            = object{CL_rlp_make_text_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                             "#2","#T",CL_medium_space,CL_dimensions_out)}
#declare twoot_dims       = CL_dimensions_out;                                      
//
#declare integral_object  = object{CL_rlp_make_integral(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,
                                                        CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        0,"#f(t)","#t","#0","#T",CL_medium_space,CL_medium_space,1,temp_dims,CL_dimensions_out)}                                                
#declare part_dims[0]     = twoot_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare a_0_rhs_object   = object{CL_rlp_make_concatenate(twoot,integral_object,CL_medium_space,part_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                      
//
#declare a_0_lhs_object   = object{CL_rlp_make_text_string("#a_0",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)} 
#declare part_dims[0]     = CL_dimensions_out;
#declare part_dims[1]     = temp_dims;
#declare third_object     = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        a_0_lhs_object,a_0_rhs_object,0,"# = ",CL_medium_space,part_dims,CL_dimensions_out)}  
//
object{third_object translate <-CL_dimensions_out[2],8,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
// a_n line
//
#declare text_func_elts   = array[4]{"#f(t)#cos","#2n|pt","#T",""};
#declare cos_term         = object{CL_rlp_make_text_function_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,
                                                                      CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                      text_func_elts,1,1,
                                                                      CL_medium_space,CL_medium_space,0,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                                                       

#declare integral_object  = object{CL_rlp_make_integral(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,
                                                        CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        cos_term,"","#t","#0","#T",CL_medium_space,CL_medium_space,1,temp_dims,CL_dimensions_out)}                                                
#declare part_dims[0]     = twoot_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare a_n_rhs_object   = object{CL_rlp_make_concatenate(twoot,integral_object,CL_medium_space,part_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                      
//
#declare a_n_lhs_object   = object{CL_rlp_make_text_string("#a_n",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)} 
#declare part_dims[0]     = CL_dimensions_out;
#declare part_dims[1]     = temp_dims;
#declare fourth_object    = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        a_n_lhs_object,a_n_rhs_object,0,"# = ",CL_medium_space,part_dims,CL_dimensions_out)}  
//
object{fourth_object translate <-CL_dimensions_out[2],0,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
// b_n line
//
#declare text_func_elts   = array[4]{"#f(t)#sin","#2n|pt","#T",""};
#declare cos_term         = object{CL_rlp_make_text_function_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,CL_letter_adjust,
                                                                      CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                      text_func_elts,1,1,
                                                                      CL_medium_space,CL_medium_space,0,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                                                       

#declare integral_object  = object{CL_rlp_make_integral(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,
                                                        CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        cos_term,"","#t","#0","#T",CL_medium_space,CL_medium_space,1,temp_dims,CL_dimensions_out)}                                                
#declare part_dims[0]     = twoot_dims;
#declare part_dims[1]     = CL_dimensions_out;
#declare b_n_rhs_object   = object{CL_rlp_make_concatenate(twoot,integral_object,CL_medium_space,part_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                      
//
#declare b_n_lhs_object   = object{CL_rlp_make_text_string("#b_n",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)} 
#declare part_dims[0]     = CL_dimensions_out;
#declare part_dims[1]     = temp_dims;
#declare fifth_object     = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        b_n_lhs_object,b_n_rhs_object,0,"# = ",CL_medium_space,part_dims,CL_dimensions_out)}  
//
object{fifth_object translate <-CL_dimensions_out[2],-8,0> pigment{rgb 1} finish{ambient 0 specular 1}} 
//
// Parsevals identity text line
//
#declare sixth_object     = object{CL_rlp_make_text_string("We also have Parseval's Identity:",CL_tiny_space,CL_letter_adjust,CL_z1,
                                                CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,CL_dimensions_out)} 
object{sixth_object translate <-CL_dimensions_out[0]/2,-15,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
// Parseval's Identity equation
//
#declare par_sum_object   = object{CL_rlp_make_sumprod(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                       0,"#a^2|,|,_n + b^2|,|,|!_n","#n=1","#|8",CL_medium_space,1,0,temp_dims,CL_dimensions_out)} 
#declare temp_dims        = CL_dimensions_out;                                      
#declare a0sqo2           = object{CL_rlp_make_text_fraction(CL_tiny_space,CL_letter_adjust,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                                    "#a^2|,|,_0","#2",CL_medium_space,CL_dimensions_out)}
#declare part_dims[1]     = temp_dims;
#declare part_dims[0]     = CL_dimensions_out;
#declare par_rhs_object   = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        a0sqo2,par_sum_object,0," + ",CL_medium_space,part_dims,CL_dimensions_out)}  
#declare temp_dims        = CL_dimensions_out;                                      
#declare part_dims[0]     = twoot_dims;
#declare part_dims[1]     = squ_int_obj_dims;
#declare par_lhs_object   = object{CL_rlp_make_concatenate(twoot,squ_int_object,CL_medium_space,part_dims,CL_dimensions_out)} 
#declare part_dims[0]     = CL_dimensions_out;
#declare part_dims[1]     = temp_dims;
#declare parseval_object  = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                        par_lhs_object,par_rhs_object,0," = ",CL_medium_space,part_dims,CL_dimensions_out)}  
//
#declare seventh_eqn_cent   = CL_dimensions_out[2];
//
object{parseval_object translate <-CL_dimensions_out[2],-22,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
//cylinder{<0,-20,0> <0,20,0> 0.2 pigment{Green}}
  ////
 //  end example  //
//_______________//
light_source{<0,50,-250> White}

camera{orthographic location<-100,50,-250> look_at <10,0,0> angle 15}

